
pow2(p)
{
	int a = 1;

	while (p--)
		a *= 2;

	return (a);
}

int ref = 32768;

struct {
	unsigned W:1, X:1, Y:6, :0;
} SYNCR;

fsys()
{
	return (ref * (4 * (SYNCR.Y + 1) * pow2(2 * SYNCR.W + SYNCR.X)));
}

main(int argc, char **argv)
{
	int sys;

	SYNCR.W = 0;
	SYNCR.X = 0;
	SYNCR.Y = 63; /* 8.3886 MHz */

	SYNCR.W = 1;
	SYNCR.X = 1;
	SYNCR.Y = 23; /* 25.165824 MHz */

	SYNCR.W = 0;
	SYNCR.X = 1;
	SYNCR.Y = 63; /* 16.777216 MHz */

#if 0
	sys = fsys();
	printf("%d = ", sys);
	printf("%d kHz = ", sys / 1000);
	printf("%d MHz\n", sys / 1000 / 1000);
#endif

	SYNCR.W = 0;
	do {
		SYNCR.X = 0;
		do {
			SYNCR.Y = 0;
			do {
				printf("%d %d %2d : ", SYNCR.W, SYNCR.X, SYNCR.Y);
				sys = fsys();
				printf("%d = ", sys);
				printf("%d kHz = ", sys / 1000);
				printf("%d MHz\n", sys / 1000 / 1000);
			} while (++SYNCR.Y);
		} while (++SYNCR.X);
	} while (++SYNCR.W);
}
