
	include regs.inc

	section .data        ; must be below 08000h
	align 1

count
count_msw ds.w 1
count_lsw ds.w 1

	section .inthand
	align 1

ICx_int
	pshm z
	ldz  # 0             ; ZK is always 0

	bclr TFLGx,z, # ICxF

	incw count_lsw,z
	bne  L0
	incw count_msw,z
L0
	pulm z
	rti

	section .text
	align 1

	global _init_anemometer, _anemometer_count, _anemometer_new

_anemometer_count        ; dword anemometer_count();
	lded count
	rts

_anemometer_new          ; dword anemometer_new(dword *state);
	xgex
	lded count
	subd 2,x
	sbce 0,x
	pshm e,d
	addd 2,x
	adce 0,x
	ste  0,x
	std  2,x
	pulm e,d
	rts

_init_anemometer
	pshm k,ccr
	orp  # 00E0h

	clrb
	tbek

	ldd  # ICx_int
	std  ICx_V

	ldab # FF
	tbek

	bset TCTLx, # EDGxB  ; trailing edge
	bclr TFLGx, # ICxF
	bset TMSKx, # ICxF

	pulm k,ccr
	rts

