
would be better to use PAI for this sensor
and ICx for windspeed.

;
; smartek SMT16030
; frequency 1 ... 4 kHz
; duty cycle = 0.31924 + 0.00472 * t_celsius
; range -45 ... +130 celsius => 0.10850 ... 0.93100
;

	include regs.inc

	section .bankf
	align 1

times           ; layout of lo/hiacc important
loacc    ds.w 1 ; during last 32...65 msec
hiacc    ds.w 1

fell     ds.w 1 ; tcnts at falling and rising edges
rose     ds.w 1

	section .inthand
	align 1

ICx_int
	pshm d,k
	ldab # FF
	tbek

	ldd  TICx
	bclr TFLGx, # ICxF
	brclr PORTGP, # PINx, falling_edge

	std  rose
	subd fell
	addd loacc
	bcc  L0
	rord
	lsrw hiacc
L0
	std  loacc
	pulm d,k
	rti

falling_edge
	std  fell
	subd rose
	addd hiacc
	bcc  L1
	rord
	lsrw loacc
L1
	std  hiacc
	pulm d,k
	rti


	section .text
	align 1

_smt16030_temperature
	pshm k
	ldab # FF
	tbek
	lded times
	pulm k
	ade
	bcc L2
	rore
	lsrd
L2
	xgex
	fdiv
	xgdx
	subd # 20922
	rts                 ; 309*celsius in D

_init_smt16030          ; void init_smt16030(void);
	pshm k,ccr
	orp  # 00E0h

	clrb
	tbek

	ldd  # ICx_int
	std  ICx_V

	ldab # FF
	tbek

	bset TCTLx, # EDGxA+EDGxB  ; both edges
	bclr TFLGx, # ICxF
	bset TMSKx, # ICxF

	pulm k,ccr
	rts

